Debian Bug report logs - #519165
set -u should not error on "${@:+}" if there are no args

version graph

Package: bash; Maintainer for bash is Matthias Klose <doko@debian.org>; Source for bash is src:bash.

Reported by: jidanni@jidanni.org

Date: Sun, 8 Mar 2009 11:48:05 UTC

Severity: grave

Tags: confirmed, upstream

Merged with 525965

Found in version bash/4.0-1

Fixed in version bash/4.0-4

Done: Matthias Klose <doko@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>:
Bug#518752; Package exim4-config. (Sun, 08 Mar 2009 11:48:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to jidanni@jidanni.org:
New Bug report received and forwarded. Copy sent to Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>. (Sun, 08 Mar 2009 11:48:07 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: jidanni@jidanni.org
To: submit@bugs.debian.org
Subject: update-exim4.conf: line 38: $@: unbound variable
Date: Sun, 08 Mar 2009 19:46:31 +0800
Package: exim4-config
Version: 4.69-9
Severity: important
File: /usr/sbin/update-exim4.conf

starting with bash version 4.0-1:

/var/log/boot:Sun Mar  8 19:13:03 2009: Starting
MTA:/usr/sbin/update-exim4.conf: line 38: $@: unbound variable

because "set -u" now applies to $@ too.




Information forwarded to debian-bugs-dist@lists.debian.org, debian-devel@lists.debian.org, Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>:
Bug#518752; Package exim4-config. (Sun, 08 Mar 2009 13:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Metzler <ametzler@downhill.at.eu.org>:
Extra info received and forwarded to list. Copy sent to debian-devel@lists.debian.org, Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>. (Sun, 08 Mar 2009 13:45:03 GMT) Full text and rfc822 format available.

Message #10 received at 518752@bugs.debian.org (full text, mbox):

From: Andreas Metzler <ametzler@downhill.at.eu.org>
To: jidanni@jidanni.org, 518752@bugs.debian.org
Cc: bash@packages.debian.org
Subject: Re: Bug#518752: update-exim4.conf: line 38: $@: unbound variable
Date: Sun, 8 Mar 2009 14:42:11 +0100
On 2009-03-08 jidanni@jidanni.org wrote:
> Package: exim4-config
> Version: 4.69-9
> Severity: important
> File: /usr/sbin/update-exim4.conf

> starting with bash version 4.0-1:

> /var/log/boot:Sun Mar  8 19:13:03 2009: Starting
> MTA:/usr/sbin/update-exim4.conf: line 38: $@: unbound variable

> because "set -u" now applies to $@ too.

Oh dear.

Upstream changelog:
d.  Fixed a bug that caused expansions of $@ and $* to not exit the shell if
    the -u option was enabled and there were no posititional parameters.

Posh also behaves this way, dash doesn't.

i.e. this
-------------
#!/bin/sh
set -u
echo "$@"
exit 0
-------------
causes "@: parameter not set" and a non-zero exitcode.

Personally I do not think this as clear cut as upstream's changelog
says. set -u should cause a failure if you try to "expand a variable
that is not set". However afaict it is not clear that the absence of
positional parameters should cause the shell to "not set" $@. The
standard just says "If there are no positional parameters, the
expansion of '@' shall generate zero fields, even when '@' is
double-quoted." So there is special-casing, "$@" expands to nul, not
the empty string.

With posh replacing "$@" with "${@:+}" works as a workaround, however
bash even then throws the error. - Is this a bug in bash?

cu andreas
-- 
`What a good friend you are to him, Dr. Maturin. His other friends are
so grateful to you.'
`I sew his ears on from time to time, sure'




Information forwarded to debian-bugs-dist@lists.debian.org, Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>:
Bug#518752; Package exim4-config. (Sun, 08 Mar 2009 22:27:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to prahal@yahoo.com:
Extra info received and forwarded to list. Copy sent to Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>. (Sun, 08 Mar 2009 22:27:05 GMT) Full text and rfc822 format available.

Message #15 received at 518752@bugs.debian.org (full text, mbox):

From: Alban browaeys <prahal@yahoo.com>
To: 518752@bugs.debian.org
Cc: Andreas Metzler <ametzler@downhill.at.eu.org>
Subject: Re: Bug#518752: update-exim4.conf: line 38: $@: unbound variable
Date: Sun, 08 Mar 2009 23:23:46 +0100
>From \amethyst on freenode #bash  (Neil Moore) :
<\amethyst> it is a bug I think
<\amethyst> that you still get the error even with ${@-foo}
<\amethyst> but ${@+"$@"}  probably shouldn't error out
<\amethyst> since ${foo+bar}  does not
<\amethyst> or ${foo+"$foo"}

I believe this should be cloned to bash (kept here too because the
current $@ is to be fixed either way).
Please tell me if you want me to do it. I ll refresh my memories of the
bts and proceed.

Cheers,
Alban





Information forwarded to debian-bugs-dist@lists.debian.org, Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>:
Bug#518752; Package exim4-config. (Tue, 10 Mar 2009 18:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Metzler <ametzler@downhill.at.eu.org>:
Extra info received and forwarded to list. Copy sent to Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>. (Tue, 10 Mar 2009 18:57:03 GMT) Full text and rfc822 format available.

Message #20 received at 518752@bugs.debian.org (full text, mbox):

From: Andreas Metzler <ametzler@downhill.at.eu.org>
To: prahal@yahoo.com, 518752@bugs.debian.org, debian-devel@lists.debian.org
Subject: Re: Bug#518752: update-exim4.conf: line 38: $@: unbound variable
Date: Tue, 10 Mar 2009 19:56:01 +0100
clone 518752 -1
reassign -1 bash
found -1 4.0-1
retitle -1 set -u should not error on "${@:+}" if there are no args
thanks

On 2009-03-08 Alban browaeys <prahal@yahoo.com> wrote:
> >From \amethyst on freenode #bash  (Neil Moore) :
> <\amethyst> it is a bug I think
> <\amethyst> that you still get the error even with ${@-foo}
> <\amethyst> but ${@+"$@"}  probably shouldn't error out
> <\amethyst> since ${foo+bar}  does not
> <\amethyst> or ${foo+"$foo"}

> I believe this should be cloned to bash (kept here too because the
> current $@ is to be fixed either way).
> Please tell me if you want me to do it. I ll refresh my memories of the
> bts and proceed.

Thanks for the heads-up. Cloning.
cu andreas
-- 
`What a good friend you are to him, Dr. Maturin. His other friends are
so grateful to you.'
`I sew his ears on from time to time, sure'




Bug 518752 cloned as bug 519165. Request was from Andreas Metzler <ametzler@downhill.at.eu.org> to control@bugs.debian.org. (Tue, 10 Mar 2009 18:57:04 GMT) Full text and rfc822 format available.

Bug reassigned from package `exim4-config' to `bash'. Request was from Andreas Metzler <ametzler@downhill.at.eu.org> to control@bugs.debian.org. (Tue, 10 Mar 2009 18:57:06 GMT) Full text and rfc822 format available.

Bug marked as found in version 4.0-1. Request was from Andreas Metzler <ametzler@downhill.at.eu.org> to control@bugs.debian.org. (Tue, 10 Mar 2009 18:57:07 GMT) Full text and rfc822 format available.

Changed Bug title to `set -u should not error on "${@:+}" if there are no args' from `update-exim4.conf: line 38: $@: unbound variable'. Request was from Andreas Metzler <ametzler@downhill.at.eu.org> to control@bugs.debian.org. (Tue, 10 Mar 2009 18:57:07 GMT) Full text and rfc822 format available.

Blocking bugs of 522255 added: 519165 Request was from Joey Hess <joeyh@debian.org> to control@bugs.debian.org. (Fri, 03 Apr 2009 18:48:14 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Matthias Klose <doko@debian.org>:
Bug#519165; Package bash. (Fri, 03 Apr 2009 18:51:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Copy sent to Matthias Klose <doko@debian.org>. (Fri, 03 Apr 2009 18:51:09 GMT) Full text and rfc822 format available.

Message #35 received at 519165@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: 519165@bugs.debian.org
Cc: 522255@bugs.debian.org
Subject: also affects debconf
Date: Fri, 3 Apr 2009 14:47:49 -0400
[Message part 1 (text/plain, inline)]
Since debconf's confmodule uses $@, to support being called
from set -u maintainer scripts it would need to either
set +u (not very nice since that would also affect its caller),
or use ${@:+}. But this bug prevents the latter; so debconf's bug,
#522255, is effectively blocked by this bug in bash.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Matthias Klose <doko@debian.org>:
Bug#519165; Package bash. (Wed, 29 Apr 2009 09:51:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to martin f krafft <madduck@debian.org>:
Extra info received and forwarded to list. Copy sent to Matthias Klose <doko@debian.org>. (Wed, 29 Apr 2009 09:51:21 GMT) Full text and rfc822 format available.

Message #40 received at 519165@bugs.debian.org (full text, mbox):

From: martin f krafft <madduck@debian.org>
To: Joey Hess <joeyh@debian.org>, 519165@bugs.debian.org
Cc: 522255@bugs.debian.org
Subject: Re: Bug#519165: also affects debconf
Date: Wed, 29 Apr 2009 11:42:23 +0200
[Message part 1 (text/plain, inline)]
also sprach Joey Hess <joeyh@debian.org> [2009.04.03.2047 +0200]:
> Since debconf's confmodule uses $@, to support being called
> from set -u maintainer scripts it would need to either
> set +u (not very nice since that would also affect its caller),
> or use ${@:+}. But this bug prevents the latter; so debconf's bug,
> #522255, is effectively blocked by this bug in bash.

As a workaround, you want to use ${@:-}, not ${@:+}.

-- 
 .''`.   martin f. krafft <madduck@d.o>      Related projects:
: :'  :  proud Debian developer               http://debiansystem.info
`. `'`   http://people.debian.org/~madduck    http://vcs-pkg.org
  `-  Debian - when you have better things to do than fixing systems
[digital_signature_gpg.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Matthias Klose <doko@debian.org>:
Bug#519165; Package bash. (Wed, 29 Apr 2009 10:24:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to martin f krafft <madduck@debian.org>:
Extra info received and forwarded to list. Copy sent to Matthias Klose <doko@debian.org>. (Wed, 29 Apr 2009 10:24:02 GMT) Full text and rfc822 format available.

Message #45 received at 519165@bugs.debian.org (full text, mbox):

From: martin f krafft <madduck@debian.org>
To: 519165@bugs.debian.org
Subject: bash 4 regression
Date: Wed, 29 Apr 2009 12:19:08 +0200
[Message part 1 (text/plain, inline)]
# justification: breaks plenty other packages,
# and if only by way of #522255
severity 518752 grave
tags 518752 upstream confirmed
thanks

also sprach Andreas Metzler <ametzler@downhill.at.eu.org> [2009.03.08.1442 +0100]:
> d.  Fixed a bug that caused expansions of $@ and $* to not exit
> the shell if the -u option was enabled and there were no
> posititional parameters.
[…]

> Personally I do not think this as clear cut as upstream's
> changelog says. set -u should cause a failure if you try to
> "expand a variable that is not set". However afaict it is not
> clear that the absence of positional parameters should cause the
> shell to "not set" $@. The standard just says "If there are no
> positional parameters, the expansion of '@' shall generate zero
> fields, even when '@' is double-quoted." So there is
> special-casing, "$@" expands to nul, not the empty string.

$@ and $* are special, and not really variables. In any context
where there are positional parameters, they are set. If there are
zero positional parameters (but the context is such that positional
parameters exist, e.g. a function, script, or after set has been
called; read: always), then their values is nothing (for $@) or the
empty string (for $*).

Maybe the standard is not clear, but all other shells do it the way
bash has always done it, so I don't see a need to deviate from that
path. There are de-facto standard, after all.

On the other hand, Goswin von Brederlow points out that the standard
is perfectly clear: "'@' shall generate zero fields" does not
suggest "shall fail to expand". Some might say it pretty clearly
says that it must not fail to expand, ever. Put differently, this
means that those two "variables" can never be undefined in the sense
of set -u.

We can debate this issue ad mortem infinitumque (but let's not).
Fact is that this is a regression, which upstream camouflaged as
a bug fix, when instead there should have been a deprecation period.
Expecting everyone to change their scripts to work around bash's
eclectic interpretation of $@/$* is not the way forward.

I am thus marking this bug grave as it breaks a lot of existing
scripts.

> With posh replacing "$@" with "${@:+}" works as a workaround, however
> bash even then throws the error. - Is this a bug in bash?

The standard defines $@ specially (see above), and given the
following example:

  madduck@piper:~$ f() { echo $#; }; g() { f "$@"; }; h() { f "${@:-}"; }; g; h
  0
  1

this does not help, since both, ${@:-} and ${@:+}, expand to at
least one field (never to zero), and you would need a workaround
using [ $# -eq 0 ], which is just unacceptable at the scale we're
talking about.

This all just goes to show that $@ (and $*) are special and must not
be treated like any plain variable. Specifically, they are *never
undefined*.

-- 
 .''`.   martin f. krafft <madduck@d.o>      Related projects:
: :'  :  proud Debian developer               http://debiansystem.info
`. `'`   http://people.debian.org/~madduck    http://vcs-pkg.org
  `-  Debian - when you have better things to do than fixing systems
[digital_signature_gpg.asc (application/pgp-signature, inline)]

Severity set to `grave' from `important' Request was from martin f krafft <madduck@debian.org> to control@bugs.debian.org. (Wed, 29 Apr 2009 11:15:04 GMT) Full text and rfc822 format available.

Tags set to: confirmed, upstream Request was from martin f krafft <madduck@debian.org> to control@bugs.debian.org. (Wed, 29 Apr 2009 11:15:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Matthias Klose <doko@debian.org>:
Bug#519165; Package bash. (Fri, 03 Jul 2009 17:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to chet.ramey@case.edu:
Extra info received and forwarded to list. Copy sent to Matthias Klose <doko@debian.org>. (Fri, 03 Jul 2009 17:54:03 GMT) Full text and rfc822 format available.

Message #54 received at 519165@bugs.debian.org (full text, mbox):

From: Chet Ramey <chet.ramey@case.edu>
To: 519165@bugs.debian.org, bug-bash@gnu.org
Cc: chet.ramey@case.edu, Matthias Klose <doko@cs.tu-berlin.de>
Subject: Re: [Fwd: Bug#519165: bash 4 regression]
Date: Fri, 03 Jul 2009 13:52:48 -0400
Matthias Klose wrote:
> wouldn't this changed behaviour warrent a compatibility switch?

I'm going to do what the Posix group decides.  Read

http://lists.gnu.org/archive/html/bug-bash/2009-06/msg00107.html

for a summary; portions of which I will reproduce below.  (And the
line that got munged in the bug-bash archives noted the inconsistency
of bash-3.2 not exiting on $@ but exiting on the variant with braces.)


> Subject: Bug#519165: bash 4 regression
> From: martin f krafft <madduck@debian.org>
> Date: Wed, 29 Apr 2009 12:19:08 +0200
>
> $@ and $* are special, and not really variables. In any context
> where there are positional parameters, they are set.

This is true.  They're not variables; they are positional parameters.

> Maybe the standard is not clear, but all other shells do it the way
> bash has always done it, so I don't see a need to deviate from that
> path. There are de-facto standard, after all.

There is, in fact a de facto standard, but the bash4 behavior is
what the Bourne and Korn shells have always done.  In fact, the only
way Martin's statement is true is if "all other shells" means "dash",
since that's the only other shell I found that doesn't apply set -u to
$@ and $*.

A partial list of shells that honor set -u when expanding $@ and $*:

bash4
all versions of the bourne shell from v7 to svr4.2
all versions of the korn shell
pdksh and variants like mksh and posh
ash and its descendents except dash

> On the other hand, Goswin von Brederlow points out that the standard
> is perfectly clear: "'@' shall generate zero fields" does not
> suggest "shall fail to expand". Some might say it pretty clearly
> says that it must not fail to expand, ever. Put differently, this
> means that those two "variables" can never be undefined in the sense
> of set -u.

Creative, but irrelevant.  The key was the "variables" language in the
Posix description of `set -u', which invalidates historical behavior.
$@ and $* are not variables.

> We can debate this issue ad mortem infinitumque (but let's not).
> Fact is that this is a regression, which upstream camouflaged as
> a bug fix, when instead there should have been a deprecation period.
> Expecting everyone to change their scripts to work around bash's
> eclectic interpretation of $@/$* is not the way forward.

Beautiful language, but incorrect.  The current bash4 behavior is
not an "eclectic interpretation," but consistent with how shells
have historically behaved.

> I am thus marking this bug grave as it breaks a lot of existing
> scripts.

Can't win, can you? :-)

When bash does something different from historical shell behavior, it
either gets slammed because the difference exists or because people
write scripts that depend on the difference. :-)

Chet

-- 
``The lyf so short, the craft so long to lerne.'' - Chaucer

Chet Ramey, ITS, CWRU    chet@case.edu    http://cnswww.cns.cwru.edu/~chet/




Information forwarded to debian-bugs-dist@lists.debian.org, Matthias Klose <doko@debian.org>:
Bug#519165; Package bash. (Mon, 06 Jul 2009 10:39:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to martin f krafft <madduck@debian.org>:
Extra info received and forwarded to list. Copy sent to Matthias Klose <doko@debian.org>. (Mon, 06 Jul 2009 10:39:02 GMT) Full text and rfc822 format available.

Message #59 received at 519165@bugs.debian.org (full text, mbox):

From: martin f krafft <madduck@debian.org>
To: chet.ramey@case.edu, 519165@bugs.debian.org
Cc: bug-bash@gnu.org, Matthias Klose <doko@cs.tu-berlin.de>
Subject: Re: Bug#519165: [Fwd: Bug#519165: bash 4 regression]
Date: Mon, 6 Jul 2009 12:33:55 +0200
[Message part 1 (text/plain, inline)]
also sprach Chet Ramey <chet.ramey@case.edu> [2009.07.03.1952 +0200]:
> There is, in fact a de facto standard, but the bash4 behavior is
> what the Bourne and Korn shells have always done.  In fact, the only
> way Martin's statement is true is if "all other shells" means "dash",
> since that's the only other shell I found that doesn't apply set -u to
> $@ and $*.
> 
> A partial list of shells that honor set -u when expanding $@ and $*:
> 
> bash4
> all versions of the bourne shell from v7 to svr4.2
> all versions of the korn shell
> pdksh and variants like mksh and posh
> ash and its descendents except dash

zsh.

> > We can debate this issue ad mortem infinitumque (but let's not).
> > Fact is that this is a regression, which upstream camouflaged as
> > a bug fix, when instead there should have been a deprecation
> > period. Expecting everyone to change their scripts to work
> > around bash's eclectic interpretation of $@/$* is not the way
> > forward.
> 
> Beautiful language, but incorrect.  The current bash4 behavior is
> not an "eclectic interpretation," but consistent with how shells
> have historically behaved.

Fine, if the standards group comes up with a standard on this, by
all means. But there really ought to be a deprecation period.

-- 
 .''`.   martin f. krafft <madduck@d.o>      Related projects:
: :'  :  proud Debian developer               http://debiansystem.info
`. `'`   http://people.debian.org/~madduck    http://vcs-pkg.org
  `-  Debian - when you have better things to do than fixing systems
[digital_signature_gpg.asc (application/pgp-signature, inline)]

Bug 522255 cloned as bug 539538. Request was from Thorsten Glaser <tg@mirbsd.de> to control@bugs.debian.org. (Sat, 01 Aug 2009 19:06:07 GMT) Full text and rfc822 format available.

Reply sent to Matthias Klose <doko@debian.org>:
You have taken responsibility. (Sun, 23 Aug 2009 16:57:12 GMT) Full text and rfc822 format available.

Notification sent to jidanni@jidanni.org:
Bug acknowledged by developer. (Sun, 23 Aug 2009 16:57:12 GMT) Full text and rfc822 format available.

Message #66 received at 519165-close@bugs.debian.org (full text, mbox):

From: Matthias Klose <doko@debian.org>
To: 519165-close@bugs.debian.org
Subject: Bug#519165: fixed in bash 4.0-4
Date: Sun, 23 Aug 2009 16:48:40 +0000
Source: bash
Source-Version: 4.0-4

We believe that the bug you reported is fixed in the latest version of
bash, which is due to be installed in the Debian FTP archive:

bash-builtins_4.0-4_i386.deb
  to pool/main/b/bash/bash-builtins_4.0-4_i386.deb
bash-doc_4.0-4_all.deb
  to pool/main/b/bash/bash-doc_4.0-4_all.deb
bash-minimal_4.0-4_i386.deb
  to pool/main/b/bash/bash-minimal_4.0-4_i386.deb
bash-static_4.0-4_i386.deb
  to pool/main/b/bash/bash-static_4.0-4_i386.deb
bash_4.0-4.diff.gz
  to pool/main/b/bash/bash_4.0-4.diff.gz
bash_4.0-4.dsc
  to pool/main/b/bash/bash_4.0-4.dsc
bash_4.0-4_i386.deb
  to pool/main/b/bash/bash_4.0-4_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 519165@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Matthias Klose <doko@debian.org> (supplier of updated bash package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 23 Aug 2009 16:09:36 +0200
Source: bash
Binary: bash bash-minimal bash-static bash-builtins bash-doc bashdb
Architecture: source all i386
Version: 4.0-4
Distribution: unstable
Urgency: low
Maintainer: Matthias Klose <doko@debian.org>
Changed-By: Matthias Klose <doko@debian.org>
Description: 
 bash       - The GNU Bourne Again SHell
 bash-builtins - Bash loadable builtins - headers & examples
 bash-doc   - Documentation and examples for the The GNU Bourne Again SHell
 bash-minimal - The GNU Bourne Again SHell (minimal version)
 bash-static - The GNU Bourne Again SHell (static version)
 bashdb     - The GNU Bourne Again SHell Debugger
Closes: 506213 519165 522857 523706 540371
Changes: 
 bash (4.0-4) unstable; urgency=low
 .
   * Apply upstream patches 024 - 028.
     - patch 028 closes: #519165. bash-4.0 reverted to the historical
       shell behavior of raising an error when $@ or $* was expanded
       after `set -u' had been executed and there were no positional
       parameters.  The Posix working group has since clarified the
       standard's position on the issue, and $@ and $* are now the only
       variables, parameters, or special parameters that do not raise an
       error when unset if set -u is enabled.
   * Enable net redirections, now that bash isn't the default shell
     anymore.
   * Changes to the skeletoon .bashrc:
     - Fix example lines in /etc/bash.bashrc to enable bash completion.
       Closes: #523706, #522857.
     - Don't export HISTCONTROL in bashrc. Closes: #540371.
     - Support user dircolors settings in ~/.dircolors. Closes: #506213.
Checksums-Sha1: 
 d7472d32b143071146b69d32e8850dbfc44fbf6a 1119 bash_4.0-4.dsc
 57de0fc74b235053fabf6ba40ab13bbc80b3f93b 98018 bash_4.0-4.diff.gz
 8714b8dda4fdb88352294ac41565e1a8d95cee4c 312096 bash-doc_4.0-4_all.deb
 e778a9a13b47fe6b13be4b3eec68c59e052dd1ff 1096928 bash_4.0-4_i386.deb
 4799d7d000f85cb9f9f6044b181a932d97c6bae9 107052 bash-builtins_4.0-4_i386.deb
 32e8a0ca4c3ea739d1b3cf64107436c4d6399d45 760136 bash-static_4.0-4_i386.deb
 d7818113edaf94882e6daa73ea665236f6afea95 223150 bash-minimal_4.0-4_i386.deb
Checksums-Sha256: 
 b12ada41b85928f81a6467849dba33bf9a5963d570ae4141562d87d4aa639911 1119 bash_4.0-4.dsc
 8fa86d5e8f26f196eb1eabf62c8de599ae3fbfa5fac6959e2b9b503e3ce570ab 98018 bash_4.0-4.diff.gz
 d207cec972085d4338b9116dec8209ecef0daa8ae14a486d3824fd4d9e9d447c 312096 bash-doc_4.0-4_all.deb
 59016011ca0b8e3fdb6d2f5b20ddb13d9a3493d138ed5242c9cd124c56cadc66 1096928 bash_4.0-4_i386.deb
 8d7dd9a8d0466b255a1bcd8abcedd3e90c50e4520366c0110d9ff972dff8d683 107052 bash-builtins_4.0-4_i386.deb
 4388efd89cbc2e9dd4367dc271a15f593877c08352afdc348d14d1f75a533546 760136 bash-static_4.0-4_i386.deb
 7d583956a63fb014cf7751ee7fa9424371c52b281582046b5b4da4b5e3c6836c 223150 bash-minimal_4.0-4_i386.deb
Files: 
 6fdd519c0f71f8a36689243b8142af2a 1119 base required bash_4.0-4.dsc
 75b06e804d135de9d2a4d6751919233b 98018 base required bash_4.0-4.diff.gz
 180a5cdcf5f304c877ca5e0c181c0dfa 312096 doc optional bash-doc_4.0-4_all.deb
 2f08f0252077f8a48ed00df7defb6cc7 1096928 shells required bash_4.0-4_i386.deb
 f4403b7b8c915d973a12e58a420cd926 107052 utils optional bash-builtins_4.0-4_i386.deb
 e0e8d34af3bd39f31cd06b3cd2fdf2db 760136 shells optional bash-static_4.0-4_i386.deb
 ec98a11be93d44bb23766b14dc9deb45 223150 shells optional bash-minimal_4.0-4_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkqRYkQACgkQStlRaw+TLJxmvACeL1dL/vOw5BhD42MIDO/Twq6Y
d5oAn1PcY4+iPCWb74ViApN2QU4b5w05
=whyA
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 21 Sep 2009 07:47:36 GMT) Full text and rfc822 format available.

Bug unarchived. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Thu, 09 Dec 2010 02:51:03 GMT) Full text and rfc822 format available.

Forcibly Merged 519165 525965. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Thu, 09 Dec 2010 02:51:03 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 06 Jan 2011 07:33:47 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 13:18:59 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.